package com.bonus.material.plan.controller;

import java.util.List;
import javax.servlet.http.HttpServletResponse;
import com.bonus.common.log.enums.OperaType;
import com.bonus.material.common.annotation.PreventRepeatSubmit;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.bonus.common.log.annotation.SysLog;
import com.bonus.common.security.annotation.RequiresPermissions;
import com.bonus.material.plan.domain.PlanBorrowInfo;
import com.bonus.material.plan.service.IPlanBorrowInfoService;
import com.bonus.common.core.web.controller.BaseController;
import com.bonus.common.core.web.domain.AjaxResult;
import com.bonus.common.core.utils.poi.ExcelUtil;
import com.bonus.common.core.web.page.TableDataInfo;

/**
 * 年度借调Controller
 * 
 * @author xsheng
 * @date 2024-10-16
 */
@Api(tags = "年度借调接口")
@RestController
@RequestMapping("/plan_borrow_info")
public class PlanBorrowInfoController extends BaseController {
    @Autowired
    private IPlanBorrowInfoService planBorrowInfoService;

    /**
     * 查询年度借调列表
     */
    @ApiOperation(value = "查询年度借调列表")
    @RequiresPermissions("plan:info:list")
    @GetMapping("/list")
    public TableDataInfo list(PlanBorrowInfo planBorrowInfo) {
        startPage();
        List<PlanBorrowInfo> list = planBorrowInfoService.selectPlanBorrowInfoList(planBorrowInfo);
        return getDataTable(list);
    }

    /**
     * 导出年度借调列表
     */
    @ApiOperation(value = "导出年度借调列表")
    @PreventRepeatSubmit
    @RequiresPermissions("plan:info:export")
    @SysLog(title = "年度借调", businessType = OperaType.EXPORT, logType = 1,module = "仓储管理->导出年度借调")
    @PostMapping("/export")
    public void export(HttpServletResponse response, PlanBorrowInfo planBorrowInfo) {
        List<PlanBorrowInfo> list = planBorrowInfoService.selectPlanBorrowInfoList(planBorrowInfo);
        ExcelUtil<PlanBorrowInfo> util = new ExcelUtil<PlanBorrowInfo>(PlanBorrowInfo.class);
        util.exportExcel(response, list, "年度借调数据");
    }

    /**
     * 获取年度借调详细信息
     */
    @ApiOperation(value = "获取年度借调详细信息")
    @RequiresPermissions("plan:info:query")
    @GetMapping(value = "/{borrowId}")
    public AjaxResult getInfo(@PathVariable("borrowId") Long borrowId) {
        return success(planBorrowInfoService.selectPlanBorrowInfoByBorrowId(borrowId));
    }

    /**
     * 新增年度借调
     */
    @ApiOperation(value = "新增年度借调")
    @PreventRepeatSubmit
    @RequiresPermissions("plan:info:add")
    @SysLog(title = "年度借调", businessType = OperaType.INSERT, logType = 1,module = "仓储管理->新增年度借调")
    @PostMapping
    public AjaxResult add(@RequestBody PlanBorrowInfo planBorrowInfo) {
        try {
            return toAjax(planBorrowInfoService.insertPlanBorrowInfo(planBorrowInfo));
        } catch (Exception e) {
            return error("系统错误, " + e.getMessage());
        }
    }

    /**
     * 修改年度借调
     */
    @ApiOperation(value = "修改年度借调")
    @PreventRepeatSubmit
    @RequiresPermissions("plan:info:edit")
    @SysLog(title = "年度借调", businessType = OperaType.UPDATE, logType = 1,module = "仓储管理->修改年度借调")
    @PutMapping
    public AjaxResult edit(@RequestBody PlanBorrowInfo planBorrowInfo) {
        try {
            return toAjax(planBorrowInfoService.updatePlanBorrowInfo(planBorrowInfo));
        } catch (Exception e) {
            return error("系统错误, " + e.getMessage());
        }
    }

    /**
     * 删除年度借调
     */
    @ApiOperation(value = "删除年度借调")
    @PreventRepeatSubmit
    @RequiresPermissions("plan:info:remove")
    @SysLog(title = "年度借调", businessType = OperaType.DELETE, logType = 1,module = "仓储管理->删除年度借调")
	@DeleteMapping("/{borrowIds}")
    public AjaxResult remove(@PathVariable Long[] borrowIds) {
        return toAjax(planBorrowInfoService.deletePlanBorrowInfoByBorrowIds(borrowIds));
    }
}
